"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var React = _interopRequireWildcard(_react);

var _reactRouterDom = require("react-router-dom");

var _reactRedux = require("react-redux");

var _actions = require("./actions");

var _Messages = require("x25/Messages");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state, _ref) {
  var selectors = _ref.settings.selectors,
      id = _ref.id;
  return {
    data: selectors.getItem(state, id),
    hasError: selectors.getItemHasError(state, id),
    fetched: selectors.getItemIsFetched(state, id),
    isFetching: selectors.getIsFetchingItemInfo(state, id),
    shouldFetch: selectors.getShouldFetchItemInfo(state, id)
  };
},
    mapDispatchToProps = function mapDispatchToProps(dispatch, _ref2) {
  var id = _ref2.id,
      settings = _ref2.settings;
  return {
    fetchItem: function fetchItem() {
      dispatch((0, _actions.fetchItem)(_extends({}, settings, {
        id: id
      })));
    }
  };
};

var LoadDataItem = function (_React$Component) {
  _inherits(LoadDataItem, _React$Component);

  function LoadDataItem() {
    _classCallCheck(this, LoadDataItem);

    return _possibleConstructorReturn(this, (LoadDataItem.__proto__ || Object.getPrototypeOf(LoadDataItem)).apply(this, arguments));
  }

  _createClass(LoadDataItem, [{
    key: "UNSAFE_componentWillMount",
    value: function UNSAFE_componentWillMount() {
      var _props = this.props,
          shouldFetch = _props.shouldFetch,
          fetchItem = _props.fetchItem;


      if (shouldFetch) {
        fetchItem();
      }
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      return this.props.data !== nextProps.data || this.props.hasError !== nextProps.hasError || this.props.fetched !== nextProps.fetched || this.props.isFetching !== nextProps.isFetching || this.props.shouldFetch !== nextProps.shouldFetch || this.props.id !== nextProps.id;
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var shouldFetch = nextProps.shouldFetch,
          fetchItem = nextProps.fetchItem;


      if (shouldFetch) {
        fetchItem();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _props2 = this.props,
          children = _props2.children,
          data = _props2.data,
          isFetching = _props2.isFetching,
          hasError = _props2.hasError,
          fetchItem = _props2.fetchItem;


      if (isFetching) {
        return React.createElement(_Messages.LoadingMessage, { message: "Preiau datele..." });
      }

      if (hasError) {
        return React.createElement(_Messages.LargeErrorMessage, {
          message: "Ceva nu a mers bine",
          onRetry: fetchItem
        });
      }

      if (data.size === 0) {
        return null;
      }

      return React.createElement(
        React.Fragment,
        null,
        children
      );
    }
  }]);

  return LoadDataItem;
}(React.Component);

exports.default = (0, _reactRouterDom.withRouter)((0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(LoadDataItem));