"use strict";

var _expect = require("expect");

var _expect2 = _interopRequireDefault(_expect);

var _actions = require("../actions");

var _actions2 = _interopRequireDefault(_actions);

var _createPaginator = require("../createPaginator");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var requestPage = _actions2.default.requestPage; /* eslint-disable max-len, no-undefined, no-magic-numbers */

describe("createPaginator", function () {

  it("should create correct request action creator", function () {
    var paginator = (0, _createPaginator.createPaginator)("some/api/endpoint", {
      pageArgName: "p",
      idKey: "id_field",
      resultsKey: "results",
      totalKey: "count"
    });
    var action = paginator.requestPage(42, "foo=bar");

    (0, _expect2.default)(action).toEqual(requestPage({
      endpoint: "some/api/endpoint",
      endpointCb: null,
      resultsKey: "results",
      totalKey: "count",
      pageArgName: "p",
      idKey: "id_field",
      page: 42,
      token: "foo=bar"
    }));
  });
});