"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchItem = undefined;

var _superagent = require("superagent");

var _superagent2 = _interopRequireDefault(_superagent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var requestPage = function requestPage(_ref) {
  var endpoint = _ref.endpoint,
      endpointCb = _ref.endpointCb,
      manageEntity = _ref.manageEntity,
      resultsKey = _ref.resultsKey,
      totalKey = _ref.totalKey,
      pageArgName = _ref.pageArgName,
      idKey = _ref.idKey,
      page = _ref.page,
      token = _ref.token;
  return {
    type: "@@redux-paginator-immutable/REQUEST_PAGE",
    meta: {
      endpoint: endpoint,
      endpointCb: endpointCb,
      manageEntity: manageEntity,
      resultsKey: resultsKey,
      totalKey: totalKey,
      pageArgName: pageArgName,
      idKey: idKey
    },
    payload: {
      page: page,
      token: token
    }
  };
};

var receivePage = function receivePage(_ref2) {
  var endpoint = _ref2.endpoint,
      endpointCb = _ref2.endpointCb,
      manageEntity = _ref2.manageEntity,
      pageArgName = _ref2.pageArgName,
      idKey = _ref2.idKey,
      page = _ref2.page,
      token = _ref2.token,
      items = _ref2.items,
      error = _ref2.error,
      total = _ref2.total;
  return {
    type: "@@redux-paginator-immutable/RECEIVE_PAGE",
    meta: {
      endpoint: endpoint,
      endpointCb: endpointCb,
      manageEntity: manageEntity,
      pageArgName: pageArgName,
      idKey: idKey
    },
    payload: {
      page: page,
      token: token,
      items: items,
      error: error,
      total: total
    }
  };
};

var resetView = function resetView(endpoint, token) {
  return {
    type: "@@redux-paginator-immutable/RESET_VIEW",
    meta: {
      endpoint: endpoint
    },
    payload: {
      token: token
    }
  };
};

var changeView = function changeView(endpoint, _ref3) {
  var token = _ref3.token,
      view = _ref3.view;
  return {
    type: "@@redux-paginator-immutable/CHANGE_VIEW",
    meta: {
      endpoint: endpoint
    },
    payload: {
      token: token,
      view: view
    }
  };
};

var clearData = function clearData(endpoint) {
  return {
    type: "@@redux-paginator-immutable/CLEAR_DATA",
    meta: {
      endpoint: endpoint
    }
  };
};

// data info

var fetchDataItemRequest = function fetchDataItemRequest(_ref4) {
  var dataItemURL = _ref4.dataItemURL,
      normalizeDataItem = _ref4.normalizeDataItem,
      id = _ref4.id;
  return new Promise(function (resolve, reject) {
    return _superagent2.default.get(dataItemURL + "/" + id).set("Accept", "application/json").end(normalizeDataItem(resolve, reject));
  });
};

var fetchItem = exports.fetchItem = function fetchItem(things) {
  return {
    type: "@@redux-paginator-immutable/FETCH_ITEM_DATA",
    payload: fetchDataItemRequest(things),
    meta: {
      id: things.id,
      endpoint: things.endpoint
    }
  };
};

exports.default = {
  clearData: clearData,
  requestPage: requestPage,
  receivePage: receivePage,
  resetView: resetView,
  changeView: changeView
};