"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchPage = exports.buildSuffix = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
/* eslint-disable no-bitwise*/

var _superagent = require("superagent");

var _superagent2 = _interopRequireDefault(_superagent);

var _queryString = require("query-string");

var _queryString2 = _interopRequireDefault(_queryString);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var buildSuffix = exports.buildSuffix = function buildSuffix(pageArgName, page, params) {
  var parsedParams = _queryString2.default.parse(params);
  var finalParsedParams = {},
      startString = "";

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Object.keys(parsedParams)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      if (parsedParams[key] === null) {
        startString += key;
      } else {
        finalParsedParams = _extends({}, finalParsedParams, _defineProperty({}, key, parsedParams[key]));
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  startString = startString === "" ? "?" : startString + "?";

  if (Object.keys(finalParsedParams).length > 0 && _queryString2.default.extract(params) !== "") {
    startString = params.replace(_queryString2.default.extract(params), "");
  }

  return startString + _queryString2.default.stringify(_extends({}, finalParsedParams, _defineProperty({}, pageArgName, page)), { encode: false }).replace(startString, "");
};

var fetchPage = exports.fetchPage = function fetchPage(_ref) {
  var endpoint = _ref.endpoint,
      pageArgName = _ref.pageArgName,
      page = _ref.page,
      token = _ref.token;

  var suffix = buildSuffix(pageArgName, page, token),
      url = endpoint + suffix;

  var promise = new Promise(function (resolve, reject) {
    return _superagent2.default.get(url).end(function (err, res) {
      return err ? reject(err) : resolve(res);
    });
  });

  return promise.then(function (res) {
    return {
      response: res.body
    };
  });
};