"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reselect = require("reselect");

/*
  Use to create a simple list where you do not need more information about
  the item. For instance, if you do NOT need to fetch more data or
  manipulate it
*/
var createReducer = function createReducer(_ref) {
  var key = _ref.key;

  var getItems = function getItems(state) {
    return state.getIn(["entities", key]);
  },
      getItem = (0, _reselect.createSelector)(getItems, function (state, id) {
    return id;
  }, function (data, id) {
    return data.get(id);
  }),
      getItemsList = (0, _reselect.createSelector)(getItems, function (data) {
    return data.toList();
  });

  return {
    getItems: getItems,
    getItem: getItem,
    getItemsList: getItemsList
  };
};

exports.default = createReducer;