"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createPaginator = exports.onlyForEndpoint = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/*
if (typeof Endpoint === "object") {
  return {
    path : Endpoint.path,
    cb   : Endpoint.cb,
  };
}

return {
  path : Endpoint,
};
*/

/* eslint-disable max-lines-per-function,  */

var _reducers = require("./reducers");

var _actions = require("./actions");

var _actions2 = _interopRequireDefault(_actions);

var _immutable = require("immutable");

var Immutable = _interopRequireWildcard(_immutable);

var _others = require("x25/utility/others");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var onlyForEndpoint = exports.onlyForEndpoint = function onlyForEndpoint(endpoint, reducer) {
  return function () {
    var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Immutable.Map();
    var action = arguments[1];

    if (typeof action.meta === "undefined" || action.meta.endpoint !== endpoint) {
      return state;
    }

    return reducer(state, action);
  };
};

var getEndpoint = function getEndpoint(data) {
  if ((typeof data === "undefined" ? "undefined" : _typeof(data)) === "object") {
    return {
      path: data.path,
      cb: data.cb
    };
  }

  return {
    path: data,
    cb: null
  };
};

var createPaginator = exports.createPaginator = function createPaginator(endpointData, settings) {
  var _getEndpoint = getEndpoint(endpointData),
      endpoint = _getEndpoint.path,
      endpointCb = _getEndpoint.cb;

  var key = settings.key,
      normalizeDataItem = settings.normalizeDataItem,
      dataItemURL = settings.dataItemURL,
      manageEntity = settings.manageEntity,
      resultsKey = settings.resultsKey,
      _settings$totalKey = settings.totalKey,
      totalKey = _settings$totalKey === undefined ? "Total" : _settings$totalKey,
      _settings$pageArgName = settings.pageArgName,
      pageArgName = _settings$pageArgName === undefined ? "page" : _settings$pageArgName,
      _settings$idKey = settings.idKey,
      idKey = _settings$idKey === undefined ? "ID" : _settings$idKey,
      _settings$rowsPerLoad = settings.rowsPerLoad,
      rowsPerLoad = _settings$rowsPerLoad === undefined ? _others.rowsPerLoad : _settings$rowsPerLoad,
      _settings$manipulateI = settings.manipulateItems,
      manipulateItems = _settings$manipulateI === undefined ? function (items) {
    return items;
  } : _settings$manipulateI;


  var endpointedActions = {
    requestPage: function requestPage(page, token) {
      return _actions2.default.requestPage({
        endpoint: endpoint,
        endpointCb: endpointCb,
        manageEntity: manageEntity,
        resultsKey: resultsKey,
        totalKey: totalKey,
        pageArgName: pageArgName,
        idKey: idKey,
        page: page,
        token: token
      });
    },
    resetView: function resetView(token) {
      return _actions2.default.resetView(endpoint, token);
    },
    changeView: function changeView(_ref) {
      var view = _ref.view,
          token = _ref.token;

      return _actions2.default.changeView(endpoint, {
        view: view,
        token: token
      });
    },
    clearData: function clearData() {
      return _actions2.default.clearData(endpoint);
    }
  };

  return _extends({
    key: key,
    normalizeDataItem: normalizeDataItem,
    dataItemURL: dataItemURL,
    manipulateItems: manipulateItems,
    rowsPerLoad: rowsPerLoad,
    manageEntity: manageEntity,
    resultsKey: resultsKey,
    endpoint: endpoint,

    pagesReducer: onlyForEndpoint(endpoint, _reducers.pages),
    itemsReducer: onlyForEndpoint(endpoint, _reducers.items),

    dataItemsReducer: onlyForEndpoint(endpoint, _reducers.dataItems)

  }, endpointedActions);
};