"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _actionTypes = require("./actionTypes");

var _actions = require("./actions");

var _actions2 = _interopRequireDefault(_actions);

var _agent = require("./agent");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-console, max-lines-per-function */

var receivePage = _actions2.default.receivePage;


var paginatorMiddleware = function paginatorMiddleware(_ref) {
  var dispatch = _ref.dispatch;
  return function (next) {
    return function (action) {
      if (action.type === _actionTypes.REQUEST_PAGE) {
        var _action$meta = action.meta,
            endpoint = _action$meta.endpoint,
            endpointCb = _action$meta.endpointCb,
            manageEntity = _action$meta.manageEntity,
            resultsKey = _action$meta.resultsKey,
            totalKey = _action$meta.totalKey,
            pageArgName = _action$meta.pageArgName,
            idKey = _action$meta.idKey,
            _action$payload = action.payload,
            page = _action$payload.page,
            token = _action$payload.token;


        dispatch(function (dispatch2) {
          var markAsError = function markAsError() {
            dispatch2(receivePage({
              endpoint: endpoint,
              endpointCb: endpointCb,
              manageEntity: manageEntity,
              pageArgName: pageArgName,
              idKey: idKey,
              page: page,
              error: true,
              token: token,
              items: [],
              total: 0
            }));
          };

          var rawPath = typeof endpointCb === "function" ? endpointCb(token) : endpoint;
          var path = rawPath === null ? "" : rawPath;

          try {
            (0, _agent.fetchPage)({
              endpoint: path,
              pageArgName: pageArgName,
              page: page,
              token: token
            }).then(function (res) {
              var response = res.response;

              var results = [],
                  total = 0;

              if (typeof resultsKey === "undefined") {
                results = response;
              } else {
                results = response[resultsKey];
                total = response[totalKey];
              }
              dispatch2(receivePage({
                endpoint: endpoint,
                endpointCb: endpointCb,
                manageEntity: manageEntity,
                pageArgName: pageArgName,
                idKey: idKey,
                page: page,
                error: false,
                token: token,
                items: results,
                total: total
              }));
            }).catch(function () {
              markAsError();
            });
          } catch (err) {
            markAsError();
          }
        });
      }
      return next(action);
    };
  };
};

exports.default = paginatorMiddleware;