"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.manageEntity = exports.manipulateItems = exports.manipulateDataItems = exports.manageDataEntity = undefined;

var _immutable = require("immutable");

var Immutable = _interopRequireWildcard(_immutable);

var _reselect = require("reselect");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// simple item

/* eslint-disable no-duplicate-imports */

var manageEntity = function manageEntity(normalizrEntity) {
  return function (item, state, keyID) {
    // prevent rewrite
    var old = state.get(String(item[keyID]));

    if (typeof old === "undefined") {
      return Immutable.Map(normalizrEntity(item));
    }

    return old;
  };
},
    manipulateItems = function manipulateItems() {
  var sortKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "ID";
  return (0, _reselect.createSelector)(function (data) {
    return data;
  }, function (data) {
    return data.sortBy(function (current) {
      return -current.get(sortKey);
    });
  });
};

// data item

var manageDataEntity = function manageDataEntity(normalizrEntity) {
  return function (item, state, keyID) {
    // prevent rewrite
    var old = state.get(String(item[keyID]));

    if (typeof old === "undefined") {
      return Immutable.Map({
        Data: normalizrEntity(item)
      });
    }

    return old;
  };
},
    manipulateDataItems = function manipulateDataItems() {
  var sortKey = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "ID";
  return (0, _reselect.createSelector)(function (data) {
    return data;
  }, function (data) {
    return data.sortBy(function (current) {
      return -current.getIn(["Data", sortKey]);
    });
  });
};

exports.manageDataEntity = manageDataEntity;
exports.manipulateDataItems = manipulateDataItems;
exports.manipulateItems = manipulateItems;
exports.manageEntity = manageEntity;